Attribute VB_Name = "Moscas_Edit"
Public Enregistrement As String
Public Eeprom() As String
Public Data() As String
Public IDtbl() As String
Public IniFile As String
Public Const TailleMem = &H1000
Public Const TailleData = &H200
Public ProvNbr As Integer
Public fMainForm As frmMain
Public DataRead As Boolean
Type Position
    Top As Long
    Bottom As LogEventTypeConstants
    Active As Boolean
End Type
Type Index
    Adress As Integer
    Contenu As String * 6
    Index As Long
    Data As String * &H18
End Type
Public Const Max_Records = 234
Public IndexTbl(1 To Max_Records) As Index
Public ProvPos(7) As Position
Public PPV(Max_Records, &HB) As String * 2
Public NbrRecords As Long

'Declaration Kernel32 functions
Public Declare Function SendMessageArray Lib "user32" Alias "SendMessageA" _
  (ByVal hwnd As Long, ByVal wMsg As Long, _
  ByVal wParam As Long, lParam As Any) As Long
Public Declare Function WritePrivateProfileString Lib "kernel32" Alias "WritePrivateProfileStringA" (ByVal lpApplicationname As String, ByVal lpKeyName As Any, ByVal lsString As Any, ByVal lplFilename As String) As Long
Public Declare Function GetPrivateProfileInt Lib "kernel32" Alias "GetPriviteProfileIntA" (ByVal lpApplicationname As String, ByVal lpKeyName As String, ByVal nDefault As Long, ByVal lpFileName As String) As Long
Public Declare Function GetPrivateProfileString Lib "kernel32" Alias "GetPrivateProfileStringA" (ByVal lpApplicationname As String, ByVal lpKeyName As String, ByVal lpDefault As String, ByVal lpReturnedString As String, ByVal nSize As Long, ByVal lpFileName As String) As Long
'*****Read INIFILE ******************
Public Function ReadSection(ByVal Header As String, ByVal Key As String) As String
Dim Reponse
Dim KeyTxt As String * 255
    Reponse = GetPrivateProfileString(Header, Key, IniFile, KeyTxt, Len(KeyTxt), IniFile)
    ReadSection = Left$(KeyTxt, Reponse)
End Function
'*****WRITE INIFILE ******************
Public Function WriteSection(ByVal Header As String, ByVal Key As String, ByVal Valeu As String) As Long
Dim Reponse
    Reponse = WritePrivateProfileString(Header, Key, Valeu, IniFile)
End Function
'*****DELETE INIFILE ******************
Public Sub DeleteSection(ByVal Header As String)
Dim Reponse
    RetourValeur = WritePrivateProfileString(Header, 0&, "", IniFile)
End Sub
'******** Hexidecimal Ascii to Decimale **********
Function Dec(ByVal InString As String) As Long
    Dec = CDec("&H" & InString)
End Function

'******** Calulte Nombre of Providers ***********
Function CalcProv() As Long
    CalcProv = 0
    For i = 0 To 7
        If (Dec(Eeprom(11)) And 2 ^ i) <> 0 Then
            CalcProv = CalcProv + 1
        End If
    Next
End Function
'*********** Check Eeprom ********************
Sub CheckPPV()
Dim Offset, Temp
    NbrRecords = Dec(Eeprom(13))
    If NbrRecords > Max_Records Then
       NbrRecords = Max_Records
       Eeprom(13) = Right$("00" & Hex$(Max_Records), 2)
    End If
    For i = 1 To NbrRecords
        Offset = (i - 1) * &HC + &H500
        If ((Left$(Eeprom(Offset + &HB), 1) = "A") Or _
            (Left$(Eeprom(Offset + &HB), 1) = "B") Or _
            (Left$(Eeprom(Offset + &HB), 1) = "D")) Then
            IndexTbl(i).Adress = Offset
            IndexTbl(i).Contenu = "PPV" & Left$(Eeprom(Offset + &HB), 1) & "X" & Right$(Eeprom(Offset + &HB), 1)
            Temp = ""
            For a = Offset To Offset + &HB
                Temp = Temp & Eeprom(a)
            Next
            IndexTbl(i).Data = Temp
            IndexTbl(i).Index = 0
        End If
        
    Next
End Sub

'******************INIT DATAS**************************
Sub InitDatas()
    ReDim Eeprom(TailleMem - 1)
    ReDim Data(TailleData - 1)
    
    For i = 0 To TailleMem - 1
        Eeprom(i) = "FF"
    Next 'initialise Eeprom memory
    For i = 0 To TailleData - 1
        Data(i) = "FF"
    Next 'initialise Data memory
    For i = 0 To 12
        Eeprom(i) = "00"
    Next
    For i = &H40 To 8 * &H4B + &H40
        Eeprom(i) = "00"
    Next
    'Eeprom(11) = "01"
    For i = 0 To 7
        Eeprom(i * &H4B + &H40) = "FF"
        Eeprom(i * &H4B + &H41) = "FF"
        Call AsciiToEep(Space$(16), Eeprom, i * &H4B + &H42, 16)
        Eeprom(i * &H4B + &H40 + &H48) = "FF"
        Eeprom(i * &H4B + &H40 + &H49) = "FF"
        Eeprom(i * &H4B + &H40 + &H4A) = "00"
    Next
    For i = 1 To Max_Records
        IndexTbl(i).Adress = 0
        IndexTbl(i).Contenu = ""
        IndexTbl(i).Index = 0
        IndexTbl(i).Data = ""
    Next
End Sub
'********* Check if Form Loaded **************
Function IsFormLoaded(FormToCheck As Form) As Integer
    Dim Y As Integer
   
    For Y = 0 To Forms.Count - 1
        If Forms(Y) Is FormToCheck Then
            IsFormLoaded = True
            Exit Function
        End If
    Next
    IsFormLoaded = False
End Function
'**************CHECKSUM D'UN RECORD*******************
Function CheckSum(Enr As String) As Long
    Dim i As Long
    CheckSum = 0
    For i = 2 To Len(Enr) - 1 Step 2
        CheckSum = CheckSum + CDec("&h" & Mid$(Enr, i, 2))
    Next
    CheckSum = CheckSum Mod 256
End Function
'************** Replace a Partital String in a String by another String ******
Function ReplaceStr(ByVal StringOrg As String, ByVal StringChk As String, ByVal StringReplace As String) As String
Dim Reponse
    Reponse = False
    For i = 1 To Len(StringOrg)
        If Mid$(StringOrg, i, Len(StringChk)) = StringChk Then
            Reponse = True
            Exit For
        End If
    Next
    If Reponse Then
        ReplaceStr = Left$(StringOrg, i - 1) & StringReplace & Right$(StringOrg, Len(StringOrg) - i)
    Else
        ReplaceStr = StringOrg
    End If
End Function
Sub MoveProv(ByVal ProvSource As Long, ByVal ProvTarget As Long)
Dim tempProv(&H4B - 1) As String
    'Save ProvSource
    For i = 0 To &H4B - 1
        tempProv(i) = Eeprom(i + ProvSource * &H4B + &H40)
    Next
    If ProvTarget < ProvSource Then
        For i = (ProvSource - 1) * &H4B + &H40 + &H4A To ProvTarget * &H4B + &H40 Step -1
            Eeprom(i + &H4B) = Eeprom(i)
        Next
    Else
        For i = ProvSource * &H4B + &H40 To ProvTarget * &H4A + &H40
            Eeprom(i) = Eeprom(i + &H4B)
        Next
    End If
    'Move ProvSource
    For i = 0 To &H4A
        Eeprom(ProvTarget * &H4B + &H40 + i) = tempProv(i)
    Next
End Sub

Sub SaveEep()
Dim Counter
Dim Somme As Long
Counter = 1
Enregistrement = ""
For a = 0 To TailleMem - 1 Step 16
    Somme = 0
    Enregistrement = ":10" & Right$("000" & Hex$(a), 4) & "00"
    Somme = Somme + CDec("&h10")
    Somme = Somme + CDec("&h" & Mid$(Enregistrement, 4, 2))
    Somme = Somme + CDec("&h" & Mid$(Enregistrement, 6, 2))
    Somme = Somme + CDec("&h00")
    For B = 0 To 15
        Enregistrement = Enregistrement & Eeprom(a + B)
        Somme = Somme + CDec("&h" & Eeprom(a + B))
    Next
    Somme = Somme Mod 256
    Enregistrement = Enregistrement & Right$("0" & Hex$(256 - Somme), 2)
    Print #1, Enregistrement
Next
Enregistrement = ":00000001FF"
Print #1, Enregistrement
End Sub
Sub ExportDonnees(ByRef Donnees() As String, Octets As Long, Start As Long, Top As Long)
Dim Counter
Dim Somme As Long
Dim CounterHex As String

For Counter = Start To Top Step 16
    CounterHex = Right$("0000" & Hex$(Counter), 4)
    Somme = 0
    Print #2, ":" & Right$("00" & Hex$(Octets), 2) & CounterHex & "00";
    Somme = Somme + CDec("&h" & Right$("00" & Hex$(Octets), 2))
    Somme = Somme + CDec("&h" & Mid$(CounterHex, 1, 2))
    Somme = Somme + CDec("&h" & Mid$(CounterHex, 3, 2))
    Somme = Somme + CDec("&h00")
    For i = (Counter - Start) / 2 To (Counter - Start) / 2 + Octets / 2 - 1
        Print #2, Donnees(i) & "00";
        Somme = Somme + CDec("&h" & Donnees(i))
        Somme = Somme + CDec("&h" & "00")
    Next
    Somme = Somme Mod 256
    Print #2, Right$("0" & Hex$(256 - Somme), 2)
Next
End Sub

Function TraitEnregistrement(ByVal Enr As String, ByVal LineCount As Long, ByVal Import As Boolean) As Boolean
    Dim Reponse
    Dim NbrDataOctets As Long
    Dim StartAdress As Long
    Dim EndAdress As Long
    
    TraitEnregistrement = False
    'Control de format : premier char = ":"
    If Mid$(Enr, 1, 1) <> ":" Then
       Reponse = MsgBox(LoadResString(1029) & LineCount, vbOKOnly)
       TraitEnregistrement = True
       Exit Function
    End If
    'Control de Format : Somme de tous les octets a partir de Longeur Jusqu'a Chksum = 0
    If CheckSum(Enr) <> 0 Then
        Reponse = MsgBox(LoadResString(1029) & LineCount, vbOKOnly)
        TraitEnregistrement = True
       Exit Function
    End If
    
    If Mid$(Enr, 8, 2) = "01" Then 'End of File
        Exit Function
    End If
    
    StartAdress = CDec("&H" & Mid$(Enr, 4, 4))
    
    If Import And _
        ((StartAdress < &H2000) Or _
         (StartAdress >= &H4400)) Then
        Exit Function
    End If
        
    If Import Then
      If (StartAdress >= &H2000) And (StartAdress <= &H3FFF) Then
        NbrDataOctets = CDec("&H" & Mid$(Enr, 2, 2)) / 2
        StartAdress = (CDec("&H" & Mid$(Enr, 4, 4)) - &H2000) / 2
        For i = 0 To NbrDataOctets - 1
           Eeprom(StartAdress) = Mid$(Enr, i * 4 + 10, 2)
           StartAdress = StartAdress + 1
        Next
      ElseIf (StartAdress >= &H4200) And (StartAdress <= &H43FF) Then
        NbrDataOctets = CDec("&H" & Mid$(Enr, 2, 2)) / 2
        StartAdress = (CDec("&H" & Mid$(Enr, 4, 4)) - &H4200) / 2
        For i = 0 To NbrDataOctets - 1
           Data(StartAdress) = Mid$(Enr, i * 4 + 10, 2)
           StartAdress = StartAdress + 1
        Next
        End If
    End If
    
    If Not Import Then
      If (StartAdress >= &H0) And (StartAdress <= &HFFF) Then
        NbrDataOctets = CDec("&H" & Mid$(Enr, 2, 2))
        StartAdress = CDec("&H" & Mid$(Enr, 4, 4))
        For i = 0 To NbrDataOctets - 1
           Eeprom(StartAdress) = Mid$(Enr, i * 2 + 10, 2)
           StartAdress = StartAdress + 1
        Next
      End If
    End If
    
End Function
Function ExportEnregistrement(ByVal Enr As String, ByVal LineCount As Long) As Boolean
    Dim Reponse
    Dim NbrDataOctets As Long
    Dim StartAdress As Long
    Dim EndAdress As Long
    
    ExportEnregistrement = False 'no error during Function
    'Control de format : premier char = ":"
    If Mid$(Enr, 1, 1) <> ":" Then
       Reponse = MsgBox(LoadResString(1029) & LineCount, vbOKOnly)
       ExportEnregistrement = True
       Exit Function
    End If
    'Control de Format : Somme de tous les octets a partir de Longeur Jusqu'a Chksum = 0
    If CheckSum(Enr) <> 0 Then
        Reponse = MsgBox(LoadResString(1029) & LineCount, vbOKOnly)
        ExportEnregistrement = True
        Exit Function
    End If
    
    If Mid$(Enr, 8, 2) = "01" Then 'End of File
        Print #2, Enr
        Exit Function
    End If
      StartAdress = CDec("&H" & Mid$(Enr, 4, 4))
      NbrDataOctets = CDec("&H" & Mid$(Enr, 2, 2))
      If StartAdress = &H2000 Then
         Call ExportDonnees(Eeprom, &H10, &H2000, &H3BEF)
      End If
      If DataRead And (StartAdress = &H4200) Then
         Call ExportDonnees(Data, &H10, &H4200, &H43FF)
      End If
      If (StartAdress >= &H2000) And (StartAdress <= &H3BEF) Then
         Exit Function
      ElseIf DataRead And (StartAdress >= &H4200) And (StartAdress <= &H43FF) Then
         Exit Function
      Else
         Print #2, Enr
      End If
End Function

Sub ShowCarte()
    frmMain.ConfigPIC.Visible = DataRead
    frmMain.Prefixe.Text = Eeprom(0) & Eeprom(1)
    Reponse = Eeprom(2) & _
              Eeprom(3) & _
              Eeprom(4) & _
              Eeprom(5) & _
              Eeprom(6) & _
              Eeprom(7)
    frmMain.Serial.Text = Format(CDec("&H" & Reponse), "0########")
    For i = 0 To 7
      If CDec("&H" & Eeprom(11)) And 2 ^ i Then
            frmMain.ActivProv(i).Value = 1
            frmMain.NameProv(i).Text = EepToAscii(Eeprom, (i * &H4B) + &H42, 16)
            frmMain.IDProv(i).Text = Eeprom(i * &H4B + &H40) & Eeprom(i * &H4B + &H41)
      Else
            frmMain.ActivProv(i).Value = 0
            If (Eeprom(i * &H4B + &H40) & Eeprom(i * &H4B + &H40)) = "FFFF" Then
                frmMain.NameProv(i).Text = ""
                frmMain.IDProv(i).Text = ""
            Else
                frmMain.NameProv(i).Text = EepToAscii(Eeprom, (i * &H4B) + &H42, 16)
                frmMain.IDProv(i).Text = Eeprom(i * &H4B + &H40) & Eeprom(i * &H4B + &H41)
            End If
      End If
    Next
    With frmMain
    .NameProv(0).DragMode = 0
    .IDProv(0).DragMode = 0
    ProvPos(0).Active = True
    
    For i = 1 To 7
        If .ActivProv(i).Value = 1 Then
            .NameProv(i).DragMode = 1
            .IDProv(i).DragMode = 1
            ProvPos(i).Active = True
        Else
            .NameProv(i).DragMode = 0
            .IDProv(i).DragMode = 1
            ProvPos(0).Active = False
        End If
    Next
    End With
End Sub
Sub InitIndex()
Dim Reponse
    NbrRecords = Dec(Eeprom(13))
    If NbrRecords > Max_Records Then
       NbrRecords = Max_Records
       Eeprom(13) = Right$("00" & Hex$(Max_Records), 2)
    End If
    For i = 0 To 7
        If (CDec("&H" & Eeprom(11)) And 2 ^ i) = 0 Then
            Exit For
        End If
        
        If (Eeprom(i * &H4B + &H40 + 25) <> "00") And (Eeprom(i * &H4B + &H40 + 25) <> "FF") Then
            IndexTbl(CDec("&h" & Eeprom(i * &H4B + &H40 + 25))).Adress = _
                (CDec("&h" & Eeprom(i * &H4B + &H40 + 25)) - 1) * &HC + &H500
            IndexTbl(CDec("&h" & Eeprom(i * &H4B + &H40 + 25))).Contenu = _
                "PBM  " & Hex$(i)
            IndexTbl(CDec("&h" & Eeprom(i * &H4B + &H40 + 25))).Index = i * &H4B + &H40 + 25
            IndexTbl(CDec("&h" & Eeprom(i * &H4B + &H40 + 25))).Data = ""
            Reponse = ""
            For C = 0 To &HB
                Reponse = Reponse + _
                Eeprom(IndexTbl(CDec("&h" & Eeprom(i * &H4B + &H40 + 25))).Adress + C)
            Next
            IndexTbl(CDec("&h" & Eeprom(i * &H4B + &H40 + 25))).Data = Reponse
       End If
        If (Eeprom(i * &H4B + &H40 + 26) <> "00") And (Eeprom(i * &H4B + &H40 + 26) <> "FF") Then
            IndexTbl(CDec("&h" & Eeprom(i * &H4B + &H40 + 26))).Adress = _
                (CDec("&h" & Eeprom(i * &H4B + &H40 + 26)) - 1) * &HC + &H500
            IndexTbl(CDec("&h" & Eeprom(i * &H4B + &H40 + 26))).Contenu = _
                "SU   " & Hex$(i)
            IndexTbl(CDec("&h" & Eeprom(i * &H4B + &H40 + 26))).Index = i * &H4B + &H40 + 26
            IndexTbl(CDec("&h" & Eeprom(i * &H4B + &H40 + 26))).Data = ""
            Reponse = ""
            For C = 0 To &HB
                Reponse = Reponse + _
                Eeprom(IndexTbl(CDec("&h" & Eeprom(i * &H4B + &H40 + 26))).Adress + C)
            Next
            IndexTbl(CDec("&h" & Eeprom(i * &H4B + &H40 + 26))).Data = Reponse
        End If
        If (Eeprom(i * &H4B + &H40 + 27) <> "00") And (Eeprom(i * &H4B + &H40 + 27) <> "FF") Then
            IndexTbl(CDec("&h" & Eeprom(i * &H4B + &H40 + 27))).Adress = _
                (CDec("&h" & Eeprom(i * &H4B + &H40 + 27)) - 1) * &HC + &H500
            IndexTbl(CDec("&h" & Eeprom(i * &H4B + &H40 + 27))).Contenu = _
                "ACT  " & Hex$(i)
            IndexTbl(CDec("&h" & Eeprom(i * &H4B + &H40 + 27))).Index = i * &H4B + &H40 + 27
            IndexTbl(CDec("&h" & Eeprom(i * &H4B + &H40 + 27))).Data = ""
            Reponse = ""
            Reponse = ""
            For C = 0 To &HB
                Reponse = Reponse + _
                Eeprom(IndexTbl(CDec("&h" & Eeprom(i * &H4B + &H40 + 27))).Adress + C)
            Next
            IndexTbl(CDec("&h" & Eeprom(i * &H4B + &H40 + 27))).Data = Reponse
        End If
        If (Eeprom(i * &H4B + &H40 + 28) <> "00") And (Eeprom(i * &H4B + &H40 + 28) <> "FF") Then
            IndexTbl(CDec("&h" & Eeprom(i * &H4B + &H40 + 28))).Adress = _
                (CDec("&h" & Eeprom(i * &H4B + &H40 + 28)) - 1) * &HC + &H500
            IndexTbl(CDec("&h" & Eeprom(i * &H4B + &H40 + 28))).Contenu = _
                "PPV  " & Hex$(i)
            IndexTbl(CDec("&h" & Eeprom(i * &H4B + &H40 + 28))).Index = i * &H4B + &H40 + 28
            IndexTbl(CDec("&h" & Eeprom(i * &H4B + &H40 + 28))).Data = ""
            Reponse = ""
            For C = 0 To &HB
                Reponse = Reponse + _
                Eeprom(IndexTbl(CDec("&h" & Eeprom(i * &H4B + &H40 + 28))).Adress + C)
            Next
            IndexTbl(CDec("&h" & Eeprom(i * &H4B + &H40 + 28))).Data = Reponse
        End If
        For B = 40 To 55
            If (Eeprom(i * &H4B + &H40 + B) <> "00") And _
                (Eeprom(i * &H4B + &H40 + B) <> "FF") Then
                IndexTbl(CDec("&h" & Eeprom(i * &H4B + &H40 + B))).Adress = _
                    (CDec("&h" & Eeprom(i * &H4B + &H40 + B)) - 1) * &HC + &H500
                IndexTbl(CDec("&h" & Eeprom(i * &H4B + &H40 + B))).Contenu = _
                    "PK" & Hex$(B - 40) & "  " & Hex$(i)
                IndexTbl(CDec("&h" & Eeprom(i * &H4B + &H40 + B))).Index = i * &H4B + &H40 + B
                IndexTbl(CDec("&h" & Eeprom(i * &H4B + &H40 + B))).Data = ""
                 Reponse = ""
                 For C = 0 To &HB
                    Reponse = Reponse + _
                        Eeprom(IndexTbl(CDec("&h" & Eeprom(i * &H4B + &H40 + B))).Adress + C)
                 Next
                 IndexTbl(CDec("&h" & Eeprom(i * &H4B + &H40 + B))).Data = Reponse
            End If
        Next
        For B = 56 To 71
            If (Eeprom(i * &H4B + &H40 + B) <> "00") And _
                 (Eeprom(i * &H4B + &H40 + B) <> "FF") Then
                IndexTbl(CDec("&h" & Eeprom(i * &H4B + &H40 + B))).Adress = _
                    (CDec("&h" & Eeprom(i * &H4B + &H40 + B)) - 1) * &HC + &H500
                IndexTbl(CDec("&h" & Eeprom(i * &H4B + &H40 + B))).Contenu = _
                    "SK" & Hex$(B - 56) & "  " & Hex$(i)
                IndexTbl(CDec("&h" & Eeprom(i * &H4B + &H40 + B))).Index = i * &H4B + &H40 + B
                IndexTbl(CDec("&h" & Eeprom(i * &H4B + &H40 + B))).Data = ""
                 Reponse = ""
                 For C = 0 To &HB
                    Reponse = Reponse + _
                        Eeprom(IndexTbl(CDec("&h" & Eeprom(i * &H4B + &H40 + B))).Adress + C)
                 Next
                 IndexTbl(CDec("&h" & Eeprom(i * &H4B + &H40 + B))).Data = Reponse
            End If
        Next
    Next
    Call CheckPPV
 End Sub
'*********** INIT PPV LIST ************
Sub InitPPV()
Const LB_SETTABSTOPS = &H192

' Create 3 tab stops in our list box (gives 4 columns), then populate the tabs
' with some values
Dim i As Integer
Dim Temp
ReDim LBTab(1 To 3) As Long
LBTab(1) = 33
LBTab(2) = 60
LBTab(3) = 173
' Set tab stops, params are Hwnd of list box, number of tabs in array, tab settings array
Temp = SendMessageArray(frmPPV.PPVlist.hwnd, LB_SETTABSTOPS, 3, LBTab(1))
    frmPPV.PPVlist.Clear
    For i = 1 To Max_Records
        If (Left$(IndexTbl(i).Contenu, 3) = "PPV") And _
            (Val(Right$(IndexTbl(i).Contenu, 1)) = ProvNbr) Then
            Temp = Format$(ProvNbr, "0#") & _
                   vbTab & _
                   Format$(i, "0###") & _
                   vbTab & _
                   IndexTbl(i).Data & _
                   vbTab
            If Mid$(IndexTbl(i).Contenu, 4, 2) = "AX" Then
                Temp = Temp & LoadResString(1139)
            End If
            If Mid$(IndexTbl(i).Contenu, 4, 2) = "BX" Then
                Temp = Temp & LoadResString(1140)
            End If
            If Mid$(IndexTbl(i).Contenu, 4, 2) = "DX" Then
                Temp = Temp & LoadResString(1141)
            End If
            frmPPV.PPVlist.AddItem Temp
        
         End If
    Next

End Sub
Sub ActivateBitsToEeprom()
     Reponse = 0
     For i = 0 To 7
        If frmMain.ActivProv(i).Value = 1 Then
            Reponse = Reponse Or 2 ^ i
        Else
            Reponse = Reponse And (&HFF Xor 2 ^ i)
        End If
     Next
     Eeprom(11) = Right$("00" & Hex$(Reponse), 2)
     If DataRead Then
        If CDec("&H" & Data(&H35)) > CDec("&H" & Eeprom(11)) Then
            Data(&H35) = Eeprom(11)
        End If
     End If
End Sub

'********** Transform EEPROM data in ASCII***********
Function EepToAscii(Eep() As String, Begin As Long, Longeur As Long) As String
    EepToAscii = ""
    For i = Begin To Begin + Longeur - 1
       EepToAscii = EepToAscii & Chr$(CDec("&H" & Eep(i)))
    Next
End Function
'********** Transform ASCII to EEPROM data **********
Sub AsciiToEep(ByVal Ascii As String, ByRef Eep() As String, ByVal Begin As Long, ByVal Longeur As Long)
    If Len(Ascii) < Longeur Then
        Ascii = Ascii & Space$(Longeur - Len(Ascii) + 1)
    End If
    For i = Begin To Begin + Longeur - 1
       Eep(i) = Right$("00" & Hex$(Asc(Mid$(Ascii, i - Begin + 1, 1))), 2)
    Next
End Sub
'********* Date Hex to Ascii *************
Function DateHExToAscii(ByVal HexDate As String) As String
    DateHExToAscii = "00/00/1990"
    Mid$(DateHExToAscii, 7, 4) = Format$((Dec(HexDate) And &HFE00) / 512 + 1990, "0000")
    Mid$(DateHExToAscii, 4, 2) = Format$((Dec(HexDate) And &H1E0) / 32, "00")
    Mid$(DateHExToAscii, 1, 2) = Format$((Dec(HexDate) And &H1F), "00")
End Function
'********** Date Ascii (DD/MM/YYYY) to HEx
Function DateAsciiToHex(ByVal AscDate As String) As String
Dim Temp
        Temp = ((Val(Mid$(AscDate, 7, 4)) - 1990) * 512) + _
               (Val(Mid$(AscDate, 4, 2)) * 32) + _
               Val(Mid$(AscDate, 1, 2))
        DateAsciiToHex = Format$(Hex$(Temp), "0###")
End Function



Sub ShowProv(ByVal Nbr As Long)
    Dim DateHex As String
    Dim DateDec As Long
    Dim DateYear As String
    Dim DateMonth As String
    Dim DateDay As String
    Dim Adress As Long
    frmProvider.Caption = "Provider " & Nbr
    frmProvider.IDProv.Text = Eeprom(Nbr * &H4B + &H40) & _
                              Eeprom(Nbr * &H4B + &H41)
    frmProvider.NameProv.Text = EepToAscii(Eeprom, (Nbr * &H4B) + &H42, 16)
    For i = 18 + &H40 To 21 + &H40
        frmProvider.PPUAProv.Text = frmProvider.PPUAProv.Text & Eeprom(Nbr * &H4B + i)
    Next
    DateHex = Eeprom(Nbr * &H4B + 22 + &H40) & Eeprom(Nbr * &H4B + 23 + &H40)
    DateDec = CDec("&H" & DateHex)
    DateYear = Format$(((DateDec And &HFE00) / 512) + 1990, "0###")
    DateMonth = Format$(((DateDec And &H1E0) / 32), "0#")
    DateDay = Format$((DateDec And &H1F), "0#")
    frmProvider.DateChoise.Year = DateYear
    frmProvider.DateChoise.Month = DateMonth
    frmProvider.DateChoise.Day = DateDay
    frmProvider.DateProv.Text = frmProvider.DateChoise.Value
    frmProvider.RegionalProv.Text = Eeprom(Nbr * &H4B + &H40 + 24)
    frmProvider.PBMProv.Text = ""
    frmProvider.StartUpProv.Text = ""
    frmProvider.ActivationProv.Text = ""
    frmProvider.PPVProv.Text = ""
    If Nbr = 0 Then
        frmProvider.PBMProv.Visible = False
        frmProvider.StartUpProv.Visible = True
        frmProvider.ActivationProv.Visible = True
        frmProvider.PPVProv.Visible = True
        For i = 1 To Max_Records
            'StartUp Record
            If IndexTbl(i).Contenu = "SU   0" Then
               frmProvider.StartUpProv.Text = Mid$(IndexTbl(i).Data, 3, 20)
            End If
            'ACTIVATION Record
            If IndexTbl(i).Contenu = "ACT  0" Then
               frmProvider.ActivationProv.Text = Mid$(IndexTbl(i).Data, 3, 20)
            End If
            'PPV Record
            If IndexTbl(i).Contenu = "PPV  0" Then
                    frmProvider.PPVProv.Text = Mid$(IndexTbl(i).Data, 3, 20)
            End If
        Next
    
    Else
        frmProvider.PBMProv.Visible = True
        frmProvider.StartUpProv.Visible = False
        frmProvider.ActivationProv.Visible = False
        frmProvider.PPVProv.Visible = False
        For i = 1 To Max_Records
            'PBM Record
            If IndexTbl(i).Contenu = "PBM  " & Hex$(Nbr) Then
               frmProvider.PBMProv.Text = Mid$(IndexTbl(i).Data, 1, 16)
               Exit For
            End If
        Next
    End If
    For i = 0 To 15
        frmProvider.PrimaryKey(i).Text = ""
        frmProvider.SecondaryKey(i).Text = ""
    Next
    For i = 1 To Max_Records
        If (Left$(IndexTbl(i).Contenu, 2) = "PK") And (Mid$(IndexTbl(i).Contenu, 6, 1) = Hex$(Nbr)) Then
               frmProvider.PrimaryKey(CDec("&H" & Mid$(IndexTbl(i).Contenu, 3, 1))).Text = Mid$(IndexTbl(i).Data, 3, 16)
        End If
        If (Left$(IndexTbl(i).Contenu, 2) = "SK") And (Mid$(IndexTbl(i).Contenu, 6, 1) = Hex$(Nbr)) Then
               frmProvider.SecondaryKey(CDec("&H" & Mid$(IndexTbl(i).Contenu, 3, 1))).Text = Mid$(IndexTbl(i).Data, 3, 16)
        End If
    Next
End Sub


Sub Main()
    IniFile = App.Path & "\MoscasEdit.ini" 'definition du fichier ini
    Load frmMain
    Call InitDatas
    frmMain.Show
End Sub



Sub LoadResStrings(frm As Form)
    On Error Resume Next


    Dim ctl As Control
    Dim obj As Object
    Dim fnt As Object
    Dim sCtlType As String
    Dim nVal As Integer


    'set the form's caption
    frm.Caption = LoadResString(CInt(frm.Tag))


    'set the font
    Set fnt = frm.Font
    fnt.Name = LoadResString(20)
    fnt.Size = CInt(LoadResString(21))
    

    'set the controls' captions using the caption
    'property for menu items and the Tag property
    'for all other controls
    For Each ctl In frm.Controls
        Set ctl.Font = fnt
        sCtlType = TypeName(ctl)
        If sCtlType = "Label" Then
            ctl.Caption = LoadResString(CInt(ctl.Tag))
        ElseIf sCtlType = "Menu" Then
            ctl.Caption = LoadResString(CInt(ctl.Caption))
        ElseIf sCtlType = "TabStrip" Then
            For Each obj In ctl.Tabs
                obj.Caption = LoadResString(CInt(obj.Tag))
                obj.ToolTipText = LoadResString(CInt(obj.ToolTipText))
            Next
        ElseIf sCtlType = "SSTab" Then
            For i = 0 To ctl.Tabs - 1
                ctl.TabCaption(i) = LoadResString(CInt(ctl.TabCaption(i)))
            Next
        ElseIf sCtlType = "Toolbar" Then
            For Each obj In ctl.Buttons
                obj.ToolTipText = LoadResString(CInt(obj.ToolTipText))
            Next
        ElseIf sCtlType = "ListView" Then
            For Each obj In ctl.ColumnHeaders
                obj.Text = LoadResString(CInt(obj.Tag))
            Next
        ElseIf sCtlType = "TextBox" Then
            ctl.ToolTipText = LoadResString(CInt(ctl.Tag))
        ElseIf sCtlType = "CheckBox" Then
            ctl.ToolTipText = LoadResString(CInt(ctl.Tag))
        Else
            nVal = 0
            nVal = Val(ctl.Tag)
            If nVal > 0 Then ctl.Caption = LoadResString(nVal)
            nVal = 0
            nVal = Val(ctl.ToolTipText)
            If nVal > 0 Then ctl.ToolTipText = LoadResString(nVal)
        End If
    Next


End Sub

